﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MvcForums.Models;
using System.Linq.Expressions;
using System.Web.Routing;

namespace MvcForums.Controllers
{
	public class PostsController : Controller
	{
		ForumsDataContext _data = null;

		ForumsDataContext Data
		{
			get
			{
				if (_data == null)
				{
					_data = new ForumsDataContext();
				}

				return _data;
			}
		}

		public ActionResult Add(int id)
		{
			Post post = new Post();
			BindingHelperExtensions.UpdateFrom(post, Request.Form);
			post.TopicID = id;
			Data.Posts.InsertOnSubmit(post);

			Data.SubmitChanges();
			return RedirectToAction(new RouteValueDictionary (new { action = "List", id = id }));
		}

		public ActionResult List(int id)
		{
			Topic topic = Data.Topics.Single(t => t.TopicID == id);
			return RenderView("List", topic);
		}

		public ActionResult Delete(int id)
		{
			Post postToDelete = Data.Posts.Single(p => p.PostID == id);
			int topicId = postToDelete.TopicID;
			Data.Posts.DeleteOnSubmit(postToDelete);
			Data.SubmitChanges();

			return RedirectToAction(new RouteValueDictionary(new { action = "List", id = topicId }));
		}
	}
}
