﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MvcForums.Models;
using System.Linq.Expressions;
using System.Web.Routing;

namespace MvcForums.Controllers
{
	public class TopicsController : Controller
	{
		ForumsDataContext _data = null;

		ForumsDataContext Data
		{
			get
			{
				if (_data == null)
				{
					_data = new ForumsDataContext();
				}

				return _data;
			}
		}

		public ActionResult Add(int id)
		{
			Category category = Data.Categories.Single(c => c.CategoryId == id);
			Topic topic = new Topic();
			topic.CategoryID = id;
			BindingHelperExtensions.UpdateFrom(topic, Request.Form);
			Data.Topics.InsertOnSubmit(topic);

			Post post = new Post();
			BindingHelperExtensions.UpdateFrom(post, Request.Form);
			post.Title = topic.Title;
			post.Topic = topic;
			Data.Posts.InsertOnSubmit(post);
			
			Data.SubmitChanges();
			return RedirectToAction(new RouteValueDictionary(new { action = "List", id = id }));
		}

		public ActionResult List(int id)
		{
			Category category = Data.Categories.Single(c => c.CategoryId == id);
			return RenderView("List", category);
		}

		public ActionResult Delete(int id)
		{
			Topic topicToDelete = Data.Topics.Single(t => t.TopicID == id);

			Data.Posts.DeleteAllOnSubmit(topicToDelete.Posts);

			int categoryId = topicToDelete.CategoryID;

			Data.Topics.DeleteOnSubmit(topicToDelete);

			Data.SubmitChanges();

			return RedirectToAction(new RouteValueDictionary(new { action = "List", id = categoryId }));
		}
	}
}
