﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" AutoEventWireup="true" CodeBehind="List.aspx.cs" Inherits="MvcForums.Views.Topics.List" %>
<%@ Import Namespace="MvcForums.Controllers" %>
<%@ Import Namespace="MvcForums.Models" %>

<asp:Content ID="Content1" ContentPlaceHolderID="MainContentPlaceHolder" runat="server">


<div class="breadcrumbs">
	<%= Html.ActionLink("MVC Forums", "Index", "Home") %>
	&gt;
	<strong><%= ViewData.Title%></strong>
</div>

<div class="description">
	<%= ViewData.Description %>
</div>

<ul class="contentList">
<% foreach (Topic topic in ViewData.Topics)
{ %>
	<li>
		<span><%= Html.ActionLink(topic.Title, "List", "Posts", new { id = topic.TopicID })%></span>
		
		<div class="deleteLink">
			<%= Html.ActionLink("Delete", "Delete", new { id = topic.TopicID })%>
		</div>
	</li>
<% } %>
</ul>


<div id="createFormWrapper" class="clearfix">
	<a href="#" id="createLink">Create new...</a>

	<div id="createForm">
		<% using (Html.Form<TopicsController>(action => action.Add(ViewData.CategoryId))) { %>

			<fieldset>
				<legend><span>Create new topic</span></legend>

				<label for="Topic.Title">Title:</label>
				<%= Html.TextBox("Topic.Title", "", new { _class = "textInput" })%>

				<label for="Post.Body">Message body:</label>
				<%= Html.TextArea("Post.Body", "", 6, 80, new { _class = "textInput" })%>

				<div class="controlButtons">
				<%= Html.SubmitButton("createButton", "Create")%> or <a href="#" id="cancelLink">cancel</a>
				</div>
			</fieldset>
			
		<%  } %>
	</div>
</div>

</asp:Content>